(*

  application: image filtering
  state: experimental
  revision: $Id: filt_config.mli,v 1.8 2004/11/20 14:25:35 tobias Exp $
 
  Metaprogramming Project
  Authors: Christoph A. Herrmann and Tobias Langhammer
  University of Passau, Department of Informatics, Chair of Programming

 Copyright (C) 2004    University of Passau, Department of Informatics
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)

type compilation = (int * int) -> int
type config = {
  mutable ic : in_channel;
  mutable oc : out_channel;
  mutable osuffix : string;
  mutable iter_indep : bool;
  mutable staged:bool;
  mutable simplify:bool;
  mutable compiler: Ppm.ppm_image -> int -> Defs.exp -> compilation;
  mutable time : bool;
  mutable iter : int;
  mutable nostage_iter : int;
  mutable timings_iter : int;
  mutable norm_range : bool;
  mutable benchmarks:bool;
  mutable margintop : int;
  mutable marginbottom : int;
  mutable marginleft : int;
  mutable marginright : int;
  mutable verbose : int;
  mutable red_formula : string;
  mutable green_formula : string;
  mutable blue_formula : string;
}
val get : unit -> config
val finalize : config -> unit

