(*

  application: image filtering
  state: experimental
  revision: $Id: timing.ml,v 1.6 2004/11/20 14:29:47 tobias Exp $
 
  Metaprogramming Project
  Authors: Christoph A. Herrmann and Tobias Langhammer
  University of Passau, Department of Informatics, Chair of Programming

 Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004 
    Institut National de Recherche en Informatique et en Automatique (INRIA)
 Copyright (C) 2004    University of Passau, Department of Informatics
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Library General Public License for more details.
 
  You should have received a copy of the GNU Library General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)



(* timer functions *)
let print_buffer = ref []

let formater = ref Format.std_formatter
                                                                               
let init_times ()= print_buffer := []

                                                                               
(* helper function to print times consisently *)
                                                                               
(*
let pt s reps elapsed =
  let t = String.sub (s^" ___________________") 0 30 in
  let reps_string = "_________ "^(string_of_int reps) in
  let len         = String.length reps_string in
  let reps_trimed = String.sub reps_string (len-10) 10 in
  print_buffer := (fun () -> (Format.fprintf !formater
                               "__ %s_%sx avg= %E msec"
                                 t reps_trimed elapsed; (Format.print_newline ()))) :: !print_buffer
 *)
 (* print in csv-format... *)
let pt s reps elapsed =
  print_buffer := (fun () ->(Format.fprintf !formater
                             "%s;%E" s elapsed;
                             (Format.print_newline ()))) :: !print_buffer
                             
                                                                               
(* do total time *)
let time reps s f =
  let initial = Sys.time() in
  let _       = while initial = (Sys.time()) do () done in
  let initial = Sys.time() in
  let result = f () in
  let final =
     (for i=1 to reps-1 do f() done;
      Sys.time ()) in
  let elapsed = (final -. initial) *. 1000.0 /. (float reps) in
  pt s reps elapsed;
  result
                                                                               
let timenew s f =
  let mx  = ref 0 in  (* Variables for fine timing construction *)
  let n  = ref 0 in
  let m  = ref 0 in
  let s1 = ref 0.0 in
  let s2 = ref 0.0 in
  let s3 = ref 0.0 in
  let _ = m:=0 in
  let _ = mx:=0 in
  let _ = s2:= (0.0) in
  let _ = s3:= (0.0) in
                                                                               
  let reps = ref 1 in (* adaptive timing code *)
  let tr   = ref 0.0 in
  let t1 = Sys.time() in
  let t2 = begin while (Sys.time() = t1) do () done; Sys.time() end in
  let r  = f () in
  let _  = (tr:=Sys.time()) in
  let _  = while (!tr -. t2 < 1.0)
           do for i=1 to !reps
              do f () done;
           reps := (!reps)*2;
           tr   := Sys.time ()
           done in (* end adaptive timing code *)
 
let _ = s1:= !tr in  (* back to fine timing code *)
let _ = for j=1 to 1 do
        while (Sys.time () = (!s1)) do
           for i=1 to 100 do
            n := (!n) + 1
          done
         done; s2:=(Sys.time ())
        done in
let _ = s1:=!s2 in
let _ = for j=1 to 10 do
        while (Sys.time () = (!s2)) do
          for i=1 to 100 do
            m := (!m) + 1
          done
         done; s2:=(Sys.time ());
         mx:= max !m !mx;
         m:=0;
         done; in
let p  = (float !n)/.(float !mx) in
let te = (!tr*.(1.0-.p)) +. (!s1*.p) in
 
  let dt = (te -. t2) in
  let n  = !reps in
  let at = dt *. 1000.0 /. (float n) in
  pt s n at;
  r
 
let print_times () =
  List.iter (fun f -> f ()) (List.rev !print_buffer);
  init_times()
 

